import{S as Et,i as xt,s as Pt,e as n,k as d,w as $,t as f,M as Dt,c as p,d as t,m as _,a as u,x as b,h as g,b as h,G as r,g as i,y as v,q as w,o as q,B as y,v as At,L as Ps}from"../chunks/vendor-hf-doc-builder.js";import{T as Lt}from"../chunks/Tip-hf-doc-builder.js";import{I as Zs}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as E}from"../chunks/CodeBlock-hf-doc-builder.js";import{I as Na,M as Ds}from"../chunks/InferenceApi-hf-doc-builder.js";function Tt(j){let a,o,e,c,m;return{c(){a=n("p"),o=f("\u{1F4A1} Learn more about how to get the dataset URLs in the "),e=n("a"),c=f("List Parquet files"),m=f(" guide."),this.h()},l(k){a=p(k,"P",{});var x=u(a);o=g(x,"\u{1F4A1} Learn more about how to get the dataset URLs in the "),e=p(x,"A",{href:!0});var C=u(e);c=g(C,"List Parquet files"),C.forEach(t),m=g(x," guide."),x.forEach(t),this.h()},h(){h(e,"href","parquet")},m(k,x){i(k,a,x),r(a,o),r(a,e),r(e,c),r(a,m)},d(k){k&&t(a)}}}function St(j){let a,o;return a=new E({props:{code:`import duckdb

url = "https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet"

con = duckdb.connect()
con.execute("INSTALL httpfs;")
con.execute("LOAD httpfs;")`,highlighted:`<span class="hljs-keyword">import</span> duckdb

url = <span class="hljs-string">&quot;https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet&quot;</span>

con = duckdb.connect()
con.execute(<span class="hljs-string">&quot;INSTALL httpfs;&quot;</span>)
con.execute(<span class="hljs-string">&quot;LOAD httpfs;&quot;</span>)`}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p:Ps,i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Ft(j){let a,o;return a=new Ds({props:{$$slots:{default:[St]},$$scope:{ctx:j}}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p(e,c){const m={};c&2&&(m.$$scope={dirty:c,ctx:e}),a.$set(m)},i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Ct(j){let a,o;return a=new E({props:{code:`var duckdb = require('duckdb');
var db = new duckdb.Database(':memory:');
var con = db.connect();
con.exec('INSTALL httpfs');
con.exec('LOAD httpfs');

const url = "https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet"`,highlighted:`<span class="hljs-keyword">var</span> duckdb = <span class="hljs-built_in">require</span>(<span class="hljs-string">&#x27;duckdb&#x27;</span>);
<span class="hljs-keyword">var</span> db = <span class="hljs-keyword">new</span> duckdb.<span class="hljs-title class_">Database</span>(<span class="hljs-string">&#x27;:memory:&#x27;</span>);
<span class="hljs-keyword">var</span> con = db.<span class="hljs-title function_">connect</span>();
con.<span class="hljs-title function_">exec</span>(<span class="hljs-string">&#x27;INSTALL httpfs&#x27;</span>);
con.<span class="hljs-title function_">exec</span>(<span class="hljs-string">&#x27;LOAD httpfs&#x27;</span>);

<span class="hljs-keyword">const</span> url = <span class="hljs-string">&quot;https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet&quot;</span>`}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p:Ps,i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Rt(j){let a,o;return a=new Ds({props:{$$slots:{default:[Ct]},$$scope:{ctx:j}}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p(e,c){const m={};c&2&&(m.$$scope={dirty:c,ctx:e}),a.$set(m)},i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Ot(j){let a,o;return a=new E({props:{code:`con.sql(f"SELECT horoscope, count(*), AVG(LENGTH(text)) AS avg_blog_length FROM '{url}' GROUP BY horoscope ORDER BY avg_blog_length DESC LIMIT(5)")
\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510
\u2502 horoscope \u2502 count_star() \u2502  avg_blog_length   \u2502
\u2502  varchar  \u2502    int64     \u2502       double       \u2502
\u251C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u253C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u253C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2524
\u2502 Aquarius  \u2502        34062 \u2502  1129.218836239798 \u2502
\u2502 Cancer    \u2502        41509 \u2502  1098.366812016671 \u2502
\u2502 Capricorn \u2502        33961 \u2502 1073.2002002296751 \u2502
\u2502 Libra     \u2502        40302 \u2502 1072.0718326633914 \u2502
\u2502 Leo       \u2502        40587 \u2502 1064.0536871412028 \u2502
\u2514\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2518`,highlighted:`con.sql(<span class="hljs-string">f&quot;SELECT horoscope, count(*), AVG(LENGTH(text)) AS avg_blog_length FROM &#x27;<span class="hljs-subst">{url}</span>&#x27; GROUP BY horoscope ORDER BY avg_blog_length DESC LIMIT(5)&quot;</span>)
\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510
\u2502 horoscope \u2502 count_star() \u2502  avg_blog_length   \u2502
\u2502  varchar  \u2502    int64     \u2502       double       \u2502
\u251C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u253C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u253C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2524
\u2502 Aquarius  \u2502        <span class="hljs-number">34062</span> \u2502  <span class="hljs-number">1129.218836239798</span> \u2502
\u2502 Cancer    \u2502        <span class="hljs-number">41509</span> \u2502  <span class="hljs-number">1098.366812016671</span> \u2502
\u2502 Capricorn \u2502        <span class="hljs-number">33961</span> \u2502 <span class="hljs-number">1073.2002002296751</span> \u2502
\u2502 Libra     \u2502        <span class="hljs-number">40302</span> \u2502 <span class="hljs-number">1072.0718326633914</span> \u2502
\u2502 Leo       \u2502        <span class="hljs-number">40587</span> \u2502 <span class="hljs-number">1064.0536871412028</span> \u2502
\u2514\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2518`}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p:Ps,i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Bt(j){let a,o;return a=new Ds({props:{$$slots:{default:[Ot]},$$scope:{ctx:j}}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p(e,c){const m={};c&2&&(m.$$scope={dirty:c,ctx:e}),a.$set(m)},i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function It(j){let a,o;return a=new E({props:{code:`con.all(\`SELECT horoscope, count(*), AVG(LENGTH(text)) AS avg_blog_length FROM '\${url}' GROUP BY horoscope ORDER BY avg_blog_length DESC LIMIT(5)\`, function(err, res) {
  if (err) {
    throw err;
  }
  console.log(res)
});`,highlighted:`con.<span class="hljs-title function_">all</span>(<span class="hljs-string">\`SELECT horoscope, count(*), AVG(LENGTH(text)) AS avg_blog_length FROM &#x27;<span class="hljs-subst">\${url}</span>&#x27; GROUP BY horoscope ORDER BY avg_blog_length DESC LIMIT(5)\`</span>, <span class="hljs-keyword">function</span>(<span class="hljs-params">err, res</span>) {
  <span class="hljs-keyword">if</span> (err) {
    <span class="hljs-keyword">throw</span> err;
  }
  <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(res)
});`}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p:Ps,i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Nt(j){let a,o;return a=new Ds({props:{$$slots:{default:[It]},$$scope:{ctx:j}}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p(e,c){const m={};c&2&&(m.$$scope={dirty:c,ctx:e}),a.$set(m)},i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Gt(j){let a,o;return a=new E({props:{code:`con.sql(f"SELECT horoscope, count(*), AVG(LENGTH(text)) AS avg_blog_length FROM read_parquet({urls[:2]}) GROUP BY horoscope ORDER BY avg_blog_length DESC LIMIT(5)")
\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510
\u2502  horoscope  \u2502 count_star() \u2502  avg_blog_length   \u2502
\u2502   varchar   \u2502    int64     \u2502       double       \u2502
\u251C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u253C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u253C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2524
\u2502 Aquarius    \u2502        49568 \u2502 1125.8306770497095 \u2502
\u2502 Cancer      \u2502        63512 \u2502   1097.95608703867 \u2502
\u2502 Libra       \u2502        60304 \u2502 1060.6110539931017 \u2502
\u2502 Capricorn   \u2502        49402 \u2502 1059.5552609206104 \u2502
\u2502 Sagittarius \u2502        50431 \u2502 1057.4589835616982 \u2502
\u2514\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2518`,highlighted:`con.sql(<span class="hljs-string">f&quot;SELECT horoscope, count(*), AVG(LENGTH(text)) AS avg_blog_length FROM read_parquet(<span class="hljs-subst">{urls[:<span class="hljs-number">2</span>]}</span>) GROUP BY horoscope ORDER BY avg_blog_length DESC LIMIT(5)&quot;</span>)
\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510
\u2502  horoscope  \u2502 count_star() \u2502  avg_blog_length   \u2502
\u2502   varchar   \u2502    int64     \u2502       double       \u2502
\u251C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u253C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u253C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2524
\u2502 Aquarius    \u2502        <span class="hljs-number">49568</span> \u2502 <span class="hljs-number">1125.8306770497095</span> \u2502
\u2502 Cancer      \u2502        <span class="hljs-number">63512</span> \u2502   <span class="hljs-number">1097.95608703867</span> \u2502
\u2502 Libra       \u2502        <span class="hljs-number">60304</span> \u2502 <span class="hljs-number">1060.6110539931017</span> \u2502
\u2502 Capricorn   \u2502        <span class="hljs-number">49402</span> \u2502 <span class="hljs-number">1059.5552609206104</span> \u2502
\u2502 Sagittarius \u2502        <span class="hljs-number">50431</span> \u2502 <span class="hljs-number">1057.4589835616982</span> \u2502
\u2514\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2518`}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p:Ps,i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Mt(j){let a,o;return a=new Ds({props:{$$slots:{default:[Gt]},$$scope:{ctx:j}}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p(e,c){const m={};c&2&&(m.$$scope={dirty:c,ctx:e}),a.$set(m)},i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Yt(j){let a,o;return a=new E({props:{code:`con.all(\`SELECT horoscope, count(*), AVG(LENGTH(text)) AS avg_blog_length FROM read_parquet(\${JSON.stringify(urls)}) GROUP BY horoscope ORDER BY avg_blog_length DESC LIMIT(5)\`, function(err, res) {
  if (err) {
    throw err;
  }
  console.log(res)
});`,highlighted:`con.<span class="hljs-title function_">all</span>(<span class="hljs-string">\`SELECT horoscope, count(*), AVG(LENGTH(text)) AS avg_blog_length FROM read_parquet(<span class="hljs-subst">\${<span class="hljs-built_in">JSON</span>.stringify(urls)}</span>) GROUP BY horoscope ORDER BY avg_blog_length DESC LIMIT(5)\`</span>, <span class="hljs-keyword">function</span>(<span class="hljs-params">err, res</span>) {
  <span class="hljs-keyword">if</span> (err) {
    <span class="hljs-keyword">throw</span> err;
  }
  <span class="hljs-variable language_">console</span>.<span class="hljs-title function_">log</span>(res)
});`}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p:Ps,i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function zt(j){let a,o;return a=new Ds({props:{$$slots:{default:[Yt]},$$scope:{ctx:j}}}),{c(){$(a.$$.fragment)},l(e){b(a.$$.fragment,e)},m(e,c){v(a,e,c),o=!0},p(e,c){const m={};c&2&&(m.$$scope={dirty:c,ctx:e}),a.$set(m)},i(e){o||(w(a.$$.fragment,e),o=!0)},o(e){q(a.$$.fragment,e),o=!1},d(e){y(a,e)}}}function Ht(j){let a,o,e,c,m,k,x,C,Ge,se,R,Me,K,Ye,ze,ee,O,As,He,Ue,Ls,Ve,ae,A,B,Ts,X,Qe,Ss,We,te,Z,ss,Je,Ke,re,I,le,P,Xe,Fs,Ze,sa,es,Cs,ea,aa,oe,as,ne,N,ta,ts,Rs,ra,la,pe,rs,ue,G,oa,ls,Os,na,pa,ce,os,ie,L,M,Bs,ns,ua,Is,ca,he,Y,ia,ps,ha,fa,fe,D,ga,us,Ns,da,_a,cs,Gs,ma,$a,ge,is,de,T,z,Ms,hs,ba,Ys,va,_e,ys,wa,me,H,qa,fs,zs,ya,ja,$e,gs,be,U,ka,ds,Hs,Ea,xa,ve,_s,we,S,V,Us,ms,Pa,Vs,Da,qe,F,$s,Aa,La,bs,Qs,Ta,Sa,ye,Q,je,js,Fa,ke,W,Ee,ks,Ca,xe,J,Pe,vs,ws,Ra,Oa,De;return k=new Zs({}),X=new Zs({}),I=new Lt({props:{$$slots:{default:[Tt]},$$scope:{ctx:j}}}),as=new E({props:{code:`r = requests.get("https://datasets-server.huggingface.co/parquet?dataset=blog_authorship_corpus")
j = r.json()
urls = [f['url'] for f in j['parquet_files'] if f['split'] == 'train']
urls
['https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet',
 'https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00001-of-00002.parquet']`,highlighted:`r = requests.get(<span class="hljs-string">&quot;https://datasets-server.huggingface.co/parquet?dataset=blog_authorship_corpus&quot;</span>)
j = r.json()
urls = [f[<span class="hljs-string">&#x27;url&#x27;</span>] <span class="hljs-keyword">for</span> f <span class="hljs-keyword">in</span> j[<span class="hljs-string">&#x27;parquet_files&#x27;</span>] <span class="hljs-keyword">if</span> f[<span class="hljs-string">&#x27;split&#x27;</span>] == <span class="hljs-string">&#x27;train&#x27;</span>]
urls
[<span class="hljs-string">&#x27;https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet&#x27;</span>,
 <span class="hljs-string">&#x27;https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00001-of-00002.parquet&#x27;</span>]`}}),rs=new E({props:{code:`import polars as pl

df = (
    pl.read_parquet("https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet")
    .groupby("horoscope")
    .agg(
        [
            pl.count(),
            pl.col("text").str.n_chars().mean().alias("avg_blog_length")
        ]
    )
    .sort("avg_blog_length", descending=True)
    .limit(5)
)
print(df)
shape: (5, 3)
\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510
\u2502 horoscope \u2506 count \u2506 avg_blog_length \u2502
\u2502 ---       \u2506 ---   \u2506 ---             \u2502
\u2502 str       \u2506 u32   \u2506 f64             \u2502
\u255E\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u256A\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u256A\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2561
\u2502 Aquarius  \u2506 34062 \u2506 1129.218836     \u2502
\u2502 Cancer    \u2506 41509 \u2506 1098.366812     \u2502
\u2502 Capricorn \u2506 33961 \u2506 1073.2002       \u2502
\u2502 Libra     \u2506 40302 \u2506 1072.071833     \u2502
\u2502 Leo       \u2506 40587 \u2506 1064.053687     \u2502
\u2514\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2518`,highlighted:`<span class="hljs-keyword">import</span> polars <span class="hljs-keyword">as</span> pl

df = (
    pl.read_parquet(<span class="hljs-string">&quot;https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet&quot;</span>)
    .groupby(<span class="hljs-string">&quot;horoscope&quot;</span>)
    .agg(
        [
            pl.count(),
            pl.col(<span class="hljs-string">&quot;text&quot;</span>).<span class="hljs-built_in">str</span>.n_chars().mean().alias(<span class="hljs-string">&quot;avg_blog_length&quot;</span>)
        ]
    )
    .sort(<span class="hljs-string">&quot;avg_blog_length&quot;</span>, descending=<span class="hljs-literal">True</span>)
    .limit(<span class="hljs-number">5</span>)
)
<span class="hljs-built_in">print</span>(df)
shape: (<span class="hljs-number">5</span>, <span class="hljs-number">3</span>)
\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510
\u2502 horoscope \u2506 count \u2506 avg_blog_length \u2502
\u2502 ---       \u2506 ---   \u2506 ---             \u2502
\u2502 <span class="hljs-built_in">str</span>       \u2506 u32   \u2506 f64             \u2502
\u255E\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u256A\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u256A\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2561
\u2502 Aquarius  \u2506 <span class="hljs-number">34062</span> \u2506 <span class="hljs-number">1129.218836</span>     \u2502
\u2502 Cancer    \u2506 <span class="hljs-number">41509</span> \u2506 <span class="hljs-number">1098.366812</span>     \u2502
\u2502 Capricorn \u2506 <span class="hljs-number">33961</span> \u2506 <span class="hljs-number">1073.2002</span>       \u2502
\u2502 Libra     \u2506 <span class="hljs-number">40302</span> \u2506 <span class="hljs-number">1072.071833</span>     \u2502
\u2502 Leo       \u2506 <span class="hljs-number">40587</span> \u2506 <span class="hljs-number">1064.053687</span>     \u2502
\u2514\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2518`}}),os=new E({props:{code:`import polars as pl
df = (
    pl.concat([pl.read_parquet(url) for url in urls])
    .groupby("horoscope")
    .agg(
        [
            pl.count(),
            pl.col("text").str.n_chars().mean().alias("avg_blog_length")
        ]
    )
    .sort("avg_blog_length", descending=True)
    .limit(5)
)
print(df)
shape: (5, 3)
\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510
\u2502 horoscope   \u2506 count \u2506 avg_blog_length \u2502
\u2502 ---         \u2506 ---   \u2506 ---             \u2502
\u2502 str         \u2506 u32   \u2506 f64             \u2502
\u255E\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u256A\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u256A\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2561
\u2502 Aquarius    \u2506 49568 \u2506 1125.830677     \u2502
\u2502 Cancer      \u2506 63512 \u2506 1097.956087     \u2502
\u2502 Libra       \u2506 60304 \u2506 1060.611054     \u2502
\u2502 Capricorn   \u2506 49402 \u2506 1059.555261     \u2502
\u2502 Sagittarius \u2506 50431 \u2506 1057.458984     \u2502
\u2514\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2518`,highlighted:`<span class="hljs-keyword">import</span> polars <span class="hljs-keyword">as</span> pl
df = (
    pl.concat([pl.read_parquet(url) <span class="hljs-keyword">for</span> url <span class="hljs-keyword">in</span> urls])
    .groupby(<span class="hljs-string">&quot;horoscope&quot;</span>)
    .agg(
        [
            pl.count(),
            pl.col(<span class="hljs-string">&quot;text&quot;</span>).<span class="hljs-built_in">str</span>.n_chars().mean().alias(<span class="hljs-string">&quot;avg_blog_length&quot;</span>)
        ]
    )
    .sort(<span class="hljs-string">&quot;avg_blog_length&quot;</span>, descending=<span class="hljs-literal">True</span>)
    .limit(<span class="hljs-number">5</span>)
)
<span class="hljs-built_in">print</span>(df)
shape: (<span class="hljs-number">5</span>, <span class="hljs-number">3</span>)
\u250C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u252C\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2510
\u2502 horoscope   \u2506 count \u2506 avg_blog_length \u2502
\u2502 ---         \u2506 ---   \u2506 ---             \u2502
\u2502 <span class="hljs-built_in">str</span>         \u2506 u32   \u2506 f64             \u2502
\u255E\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u256A\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u256A\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2550\u2561
\u2502 Aquarius    \u2506 <span class="hljs-number">49568</span> \u2506 <span class="hljs-number">1125.830677</span>     \u2502
\u2502 Cancer      \u2506 <span class="hljs-number">63512</span> \u2506 <span class="hljs-number">1097.956087</span>     \u2502
\u2502 Libra       \u2506 <span class="hljs-number">60304</span> \u2506 <span class="hljs-number">1060.611054</span>     \u2502
\u2502 Capricorn   \u2506 <span class="hljs-number">49402</span> \u2506 <span class="hljs-number">1059.555261</span>     \u2502
\u2502 Sagittarius \u2506 <span class="hljs-number">50431</span> \u2506 <span class="hljs-number">1057.458984</span>     \u2502
\u2514\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2534\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2518`}}),ns=new Zs({}),is=new E({props:{code:`import polars as pl

q = (
    pl.scan_parquet("https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet")
    .groupby("horoscope")
    .agg(
        [
            pl.count(),
            pl.col("text").str.n_chars().mean().alias("avg_blog_length")
        ]
    )
    .sort("avg_blog_length", descending=True)
    .limit(5)
)
df = q.collect()`,highlighted:`<span class="hljs-keyword">import</span> polars <span class="hljs-keyword">as</span> pl

q = (
    pl.scan_parquet(<span class="hljs-string">&quot;https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet&quot;</span>)
    .groupby(<span class="hljs-string">&quot;horoscope&quot;</span>)
    .agg(
        [
            pl.count(),
            pl.col(<span class="hljs-string">&quot;text&quot;</span>).<span class="hljs-built_in">str</span>.n_chars().mean().alias(<span class="hljs-string">&quot;avg_blog_length&quot;</span>)
        ]
    )
    .sort(<span class="hljs-string">&quot;avg_blog_length&quot;</span>, descending=<span class="hljs-literal">True</span>)
    .limit(<span class="hljs-number">5</span>)
)
df = q.collect()`}}),hs=new Zs({}),gs=new E({props:{code:`import pandas as pd

df = (
    pd.read_parquet("https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet")
    .groupby('horoscope')['text']
    .apply(lambda x: x.str.len().mean())
    .sort_values(ascending=False)
    .head(5)
)`,highlighted:`<span class="hljs-keyword">import</span> pandas <span class="hljs-keyword">as</span> pd

df = (
    pd.read_parquet(<span class="hljs-string">&quot;https://huggingface.co/datasets/blog_authorship_corpus/resolve/refs%2Fconvert%2Fparquet/blog_authorship_corpus/blog_authorship_corpus-train-00000-of-00002.parquet&quot;</span>)
    .groupby(<span class="hljs-string">&#x27;horoscope&#x27;</span>)[<span class="hljs-string">&#x27;text&#x27;</span>]
    .apply(<span class="hljs-keyword">lambda</span> x: x.<span class="hljs-built_in">str</span>.<span class="hljs-built_in">len</span>().mean())
    .sort_values(ascending=<span class="hljs-literal">False</span>)
    .head(<span class="hljs-number">5</span>)
)`}}),_s=new E({props:{code:`df = (
      pd.concat([pd.read_parquet(url) for url in urls])
      .groupby('horoscope')['text']
      .apply(lambda x: x.str.len().mean())
      .sort_values(ascending=False)
      .head(5)
)`,highlighted:`df = (
      pd.concat([pd.read_parquet(url) <span class="hljs-keyword">for</span> url <span class="hljs-keyword">in</span> urls])
      .groupby(<span class="hljs-string">&#x27;horoscope&#x27;</span>)[<span class="hljs-string">&#x27;text&#x27;</span>]
      .apply(<span class="hljs-keyword">lambda</span> x: x.<span class="hljs-built_in">str</span>.<span class="hljs-built_in">len</span>().mean())
      .sort_values(ascending=<span class="hljs-literal">False</span>)
      .head(<span class="hljs-number">5</span>)
)`}}),ms=new Zs({}),Q=new Na({props:{python:!0,js:!0,curl:!1,$$slots:{js:[Rt],python:[Ft]},$$scope:{ctx:j}}}),W=new Na({props:{python:!0,js:!0,curl:!1,$$slots:{js:[Nt],python:[Bt]},$$scope:{ctx:j}}}),J=new Na({props:{python:!0,js:!0,curl:!1,$$slots:{js:[zt],python:[Mt]},$$scope:{ctx:j}}}),{c(){a=n("meta"),o=d(),e=n("h1"),c=n("a"),m=n("span"),$(k.$$.fragment),x=d(),C=n("span"),Ge=f("Query datasets from Datasets Server"),se=d(),R=n("p"),Me=f("Datasets Server automatically converts and publishes datasets on the Hub as Parquet files. "),K=n("a"),Ye=f("Parquet"),ze=f(" files are column-based and they shine when you\u2019re working with big data. There are several ways you can work with Parquet files, and this guide will show you how to:"),ee=d(),O=n("ul"),As=n("li"),He=f("read and query Parquet files with Pandas and Polars"),Ue=d(),Ls=n("li"),Ve=f("connect, read and query Parquet files with DuckDB and DuckDB-Wasm"),ae=d(),A=n("h2"),B=n("a"),Ts=n("span"),$(X.$$.fragment),Qe=d(),Ss=n("span"),We=f("Polars"),te=d(),Z=n("p"),ss=n("a"),Je=f("Polars"),Ke=f(" is a fast DataFrame library written in Rust with Arrow as its foundation."),re=d(),$(I.$$.fragment),le=d(),P=n("p"),Xe=f("Let\u2019s start by grabbing the URLs to the "),Fs=n("code"),Ze=f("train"),sa=f(" split of the "),es=n("a"),Cs=n("code"),ea=f("blog_authorship_corpus"),aa=f(" dataset from Datasets Server:"),oe=d(),$(as.$$.fragment),ne=d(),N=n("p"),ta=f("To read from a single Parquet file, use the "),ts=n("a"),Rs=n("code"),ra=f("read_parquet"),la=f(" function to read it into a DataFrame and then execute your query:"),pe=d(),$(rs.$$.fragment),ue=d(),G=n("p"),oa=f("To read multiple Parquet files - for example, if the dataset is sharded - you\u2019ll need to use the "),ls=n("a"),Os=n("code"),na=f("concat"),pa=f(" function to concatenate the files into a single DataFrame:"),ce=d(),$(os.$$.fragment),ie=d(),L=n("h3"),M=n("a"),Bs=n("span"),$(ns.$$.fragment),ua=d(),Is=n("span"),ca=f("Lazy API"),he=d(),Y=n("p"),ia=f("Polars offers a "),ps=n("a"),ha=f("lazy API"),fa=f(" that is more performant and memory-efficient for large Parquet files. The LazyFrame API keeps track of what you want to do, and it\u2019ll only execute the entire query when you\u2019re ready. This way, the lazy API doesn\u2019t load everything into RAM beforehand, and it allows you to work with datasets larger than your available RAM."),fe=d(),D=n("p"),ga=f("To lazily read a Parquet file, use the "),us=n("a"),Ns=n("code"),da=f("scan_parquet"),_a=f(" function instead. Then, execute the entire query with the "),cs=n("a"),Gs=n("code"),ma=f("collect"),$a=f(" function:"),ge=d(),$(is.$$.fragment),de=d(),T=n("h2"),z=n("a"),Ms=n("span"),$(hs.$$.fragment),ba=d(),Ys=n("span"),va=f("Pandas"),_e=d(),ys=n("p"),wa=f("You can also use the popular Pandas DataFrame library to read Parquet files."),me=d(),H=n("p"),qa=f("To read from a single Parquet file, use the "),fs=n("a"),zs=n("code"),ya=f("read_parquet"),ja=f(" function to read it into a DataFrame:"),$e=d(),$(gs.$$.fragment),be=d(),U=n("p"),ka=f("To read multiple Parquet files - for example, if the dataset is sharded - you\u2019ll need to use the "),ds=n("a"),Hs=n("code"),Ea=f("concat"),xa=f(" function to concatenate the files into a single DataFrame:"),ve=d(),$(_s.$$.fragment),we=d(),S=n("h2"),V=n("a"),Us=n("span"),$(ms.$$.fragment),Pa=d(),Vs=n("span"),Da=f("DuckDB"),qe=d(),F=n("p"),$s=n("a"),Aa=f("DuckDB"),La=f(" is a database that supports reading and querying Parquet files really fast. Begin by creating a connection to DuckDB, and then install and load the "),bs=n("a"),Qs=n("code"),Ta=f("httpfs"),Sa=f(" extension to read and write remote files:"),ye=d(),$(Q.$$.fragment),je=d(),js=n("p"),Fa=f("Now you can write and execute your SQL query on the Parquet file:"),ke=d(),$(W.$$.fragment),Ee=d(),ks=n("p"),Ca=f("To query multiple files - for example, if the dataset is sharded:"),xe=d(),$(J.$$.fragment),Pe=d(),vs=n("p"),ws=n("a"),Ra=f("DuckDB-Wasm"),Oa=f(", a package powered by , is also availabe for running DuckDB in a browser. This could be useful, for instance, if you want to create a web app to query Parquet files from the browser!"),this.h()},l(s){const l=Dt('[data-svelte="svelte-1phssyn"]',document.head);a=p(l,"META",{name:!0,content:!0}),l.forEach(t),o=_(s),e=p(s,"H1",{class:!0});var qs=u(e);c=p(qs,"A",{id:!0,class:!0,href:!0});var Ws=u(c);m=p(Ws,"SPAN",{});var Js=u(m);b(k.$$.fragment,Js),Js.forEach(t),Ws.forEach(t),x=_(qs),C=p(qs,"SPAN",{});var Ks=u(C);Ge=g(Ks,"Query datasets from Datasets Server"),Ks.forEach(t),qs.forEach(t),se=_(s),R=p(s,"P",{});var Ae=u(R);Me=g(Ae,"Datasets Server automatically converts and publishes datasets on the Hub as Parquet files. "),K=p(Ae,"A",{href:!0,rel:!0});var Ga=u(K);Ye=g(Ga,"Parquet"),Ga.forEach(t),ze=g(Ae," files are column-based and they shine when you\u2019re working with big data. There are several ways you can work with Parquet files, and this guide will show you how to:"),Ae.forEach(t),ee=_(s),O=p(s,"UL",{});var Le=u(O);As=p(Le,"LI",{});var Ma=u(As);He=g(Ma,"read and query Parquet files with Pandas and Polars"),Ma.forEach(t),Ue=_(Le),Ls=p(Le,"LI",{});var Ya=u(Ls);Ve=g(Ya,"connect, read and query Parquet files with DuckDB and DuckDB-Wasm"),Ya.forEach(t),Le.forEach(t),ae=_(s),A=p(s,"H2",{class:!0});var Te=u(A);B=p(Te,"A",{id:!0,class:!0,href:!0});var za=u(B);Ts=p(za,"SPAN",{});var Ha=u(Ts);b(X.$$.fragment,Ha),Ha.forEach(t),za.forEach(t),Qe=_(Te),Ss=p(Te,"SPAN",{});var Ua=u(Ss);We=g(Ua,"Polars"),Ua.forEach(t),Te.forEach(t),te=_(s),Z=p(s,"P",{});var Ba=u(Z);ss=p(Ba,"A",{href:!0,rel:!0});var Va=u(ss);Je=g(Va,"Polars"),Va.forEach(t),Ke=g(Ba," is a fast DataFrame library written in Rust with Arrow as its foundation."),Ba.forEach(t),re=_(s),b(I.$$.fragment,s),le=_(s),P=p(s,"P",{});var Es=u(P);Xe=g(Es,"Let\u2019s start by grabbing the URLs to the "),Fs=p(Es,"CODE",{});var Qa=u(Fs);Ze=g(Qa,"train"),Qa.forEach(t),sa=g(Es," split of the "),es=p(Es,"A",{href:!0,rel:!0});var Wa=u(es);Cs=p(Wa,"CODE",{});var Ja=u(Cs);ea=g(Ja,"blog_authorship_corpus"),Ja.forEach(t),Wa.forEach(t),aa=g(Es," dataset from Datasets Server:"),Es.forEach(t),oe=_(s),b(as.$$.fragment,s),ne=_(s),N=p(s,"P",{});var Se=u(N);ta=g(Se,"To read from a single Parquet file, use the "),ts=p(Se,"A",{href:!0,rel:!0});var Ka=u(ts);Rs=p(Ka,"CODE",{});var Xa=u(Rs);ra=g(Xa,"read_parquet"),Xa.forEach(t),Ka.forEach(t),la=g(Se," function to read it into a DataFrame and then execute your query:"),Se.forEach(t),pe=_(s),b(rs.$$.fragment,s),ue=_(s),G=p(s,"P",{});var Fe=u(G);oa=g(Fe,"To read multiple Parquet files - for example, if the dataset is sharded - you\u2019ll need to use the "),ls=p(Fe,"A",{href:!0,rel:!0});var Za=u(ls);Os=p(Za,"CODE",{});var st=u(Os);na=g(st,"concat"),st.forEach(t),Za.forEach(t),pa=g(Fe," function to concatenate the files into a single DataFrame:"),Fe.forEach(t),ce=_(s),b(os.$$.fragment,s),ie=_(s),L=p(s,"H3",{class:!0});var Ce=u(L);M=p(Ce,"A",{id:!0,class:!0,href:!0});var et=u(M);Bs=p(et,"SPAN",{});var at=u(Bs);b(ns.$$.fragment,at),at.forEach(t),et.forEach(t),ua=_(Ce),Is=p(Ce,"SPAN",{});var tt=u(Is);ca=g(tt,"Lazy API"),tt.forEach(t),Ce.forEach(t),he=_(s),Y=p(s,"P",{});var Re=u(Y);ia=g(Re,"Polars offers a "),ps=p(Re,"A",{href:!0,rel:!0});var rt=u(ps);ha=g(rt,"lazy API"),rt.forEach(t),fa=g(Re," that is more performant and memory-efficient for large Parquet files. The LazyFrame API keeps track of what you want to do, and it\u2019ll only execute the entire query when you\u2019re ready. This way, the lazy API doesn\u2019t load everything into RAM beforehand, and it allows you to work with datasets larger than your available RAM."),Re.forEach(t),fe=_(s),D=p(s,"P",{});var xs=u(D);ga=g(xs,"To lazily read a Parquet file, use the "),us=p(xs,"A",{href:!0,rel:!0});var lt=u(us);Ns=p(lt,"CODE",{});var ot=u(Ns);da=g(ot,"scan_parquet"),ot.forEach(t),lt.forEach(t),_a=g(xs," function instead. Then, execute the entire query with the "),cs=p(xs,"A",{href:!0,rel:!0});var nt=u(cs);Gs=p(nt,"CODE",{});var pt=u(Gs);ma=g(pt,"collect"),pt.forEach(t),nt.forEach(t),$a=g(xs," function:"),xs.forEach(t),ge=_(s),b(is.$$.fragment,s),de=_(s),T=p(s,"H2",{class:!0});var Oe=u(T);z=p(Oe,"A",{id:!0,class:!0,href:!0});var ut=u(z);Ms=p(ut,"SPAN",{});var ct=u(Ms);b(hs.$$.fragment,ct),ct.forEach(t),ut.forEach(t),ba=_(Oe),Ys=p(Oe,"SPAN",{});var it=u(Ys);va=g(it,"Pandas"),it.forEach(t),Oe.forEach(t),_e=_(s),ys=p(s,"P",{});var ht=u(ys);wa=g(ht,"You can also use the popular Pandas DataFrame library to read Parquet files."),ht.forEach(t),me=_(s),H=p(s,"P",{});var Be=u(H);qa=g(Be,"To read from a single Parquet file, use the "),fs=p(Be,"A",{href:!0,rel:!0});var ft=u(fs);zs=p(ft,"CODE",{});var gt=u(zs);ya=g(gt,"read_parquet"),gt.forEach(t),ft.forEach(t),ja=g(Be," function to read it into a DataFrame:"),Be.forEach(t),$e=_(s),b(gs.$$.fragment,s),be=_(s),U=p(s,"P",{});var Ie=u(U);ka=g(Ie,"To read multiple Parquet files - for example, if the dataset is sharded - you\u2019ll need to use the "),ds=p(Ie,"A",{href:!0,rel:!0});var dt=u(ds);Hs=p(dt,"CODE",{});var _t=u(Hs);Ea=g(_t,"concat"),_t.forEach(t),dt.forEach(t),xa=g(Ie," function to concatenate the files into a single DataFrame:"),Ie.forEach(t),ve=_(s),b(_s.$$.fragment,s),we=_(s),S=p(s,"H2",{class:!0});var Ne=u(S);V=p(Ne,"A",{id:!0,class:!0,href:!0});var mt=u(V);Us=p(mt,"SPAN",{});var $t=u(Us);b(ms.$$.fragment,$t),$t.forEach(t),mt.forEach(t),Pa=_(Ne),Vs=p(Ne,"SPAN",{});var bt=u(Vs);Da=g(bt,"DuckDB"),bt.forEach(t),Ne.forEach(t),qe=_(s),F=p(s,"P",{});var Xs=u(F);$s=p(Xs,"A",{href:!0,rel:!0});var vt=u($s);Aa=g(vt,"DuckDB"),vt.forEach(t),La=g(Xs," is a database that supports reading and querying Parquet files really fast. Begin by creating a connection to DuckDB, and then install and load the "),bs=p(Xs,"A",{href:!0,rel:!0});var wt=u(bs);Qs=p(wt,"CODE",{});var qt=u(Qs);Ta=g(qt,"httpfs"),qt.forEach(t),wt.forEach(t),Sa=g(Xs," extension to read and write remote files:"),Xs.forEach(t),ye=_(s),b(Q.$$.fragment,s),je=_(s),js=p(s,"P",{});var yt=u(js);Fa=g(yt,"Now you can write and execute your SQL query on the Parquet file:"),yt.forEach(t),ke=_(s),b(W.$$.fragment,s),Ee=_(s),ks=p(s,"P",{});var jt=u(ks);Ca=g(jt,"To query multiple files - for example, if the dataset is sharded:"),jt.forEach(t),xe=_(s),b(J.$$.fragment,s),Pe=_(s),vs=p(s,"P",{});var Ia=u(vs);ws=p(Ia,"A",{href:!0,rel:!0});var kt=u(ws);Ra=g(kt,"DuckDB-Wasm"),kt.forEach(t),Oa=g(Ia,", a package powered by , is also availabe for running DuckDB in a browser. This could be useful, for instance, if you want to create a web app to query Parquet files from the browser!"),Ia.forEach(t),this.h()},h(){h(a,"name","hf:doc:metadata"),h(a,"content",JSON.stringify(Ut)),h(c,"id","query-datasets-from-datasets-server"),h(c,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(c,"href","#query-datasets-from-datasets-server"),h(e,"class","relative group"),h(K,"href","https://parquet.apache.org/docs/"),h(K,"rel","nofollow"),h(B,"id","polars"),h(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(B,"href","#polars"),h(A,"class","relative group"),h(ss,"href","https://pola-rs.github.io/polars-book/user-guide/introduction.html"),h(ss,"rel","nofollow"),h(es,"href","https://huggingface.co/datasets/blog_authorship_corpus"),h(es,"rel","nofollow"),h(ts,"href","https://pola-rs.github.io/polars/py-polars/html/reference/api/polars.read_parquet.html"),h(ts,"rel","nofollow"),h(ls,"href","https://pola-rs.github.io/polars/py-polars/html/reference/api/polars.concat.html"),h(ls,"rel","nofollow"),h(M,"id","lazy-api"),h(M,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(M,"href","#lazy-api"),h(L,"class","relative group"),h(ps,"href","https://pola-rs.github.io/polars-book/user-guide/lazy-api/intro.html"),h(ps,"rel","nofollow"),h(us,"href","https://pola-rs.github.io/polars/py-polars/html/reference/api/polars.scan_parquet.html"),h(us,"rel","nofollow"),h(cs,"href","https://pola-rs.github.io/polars/py-polars/html/reference/lazyframe/api/polars.LazyFrame.collect.html"),h(cs,"rel","nofollow"),h(z,"id","pandas"),h(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(z,"href","#pandas"),h(T,"class","relative group"),h(fs,"href","https://pandas.pydata.org/docs/reference/api/pandas.read_parquet.html"),h(fs,"rel","nofollow"),h(ds,"href","https://pandas.pydata.org/docs/reference/api/pandas.concat.html"),h(ds,"rel","nofollow"),h(V,"id","duckdb"),h(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(V,"href","#duckdb"),h(S,"class","relative group"),h($s,"href","https://duckdb.org/docs/"),h($s,"rel","nofollow"),h(bs,"href","https://duckdb.org/docs/extensions/httpfs.html"),h(bs,"rel","nofollow"),h(ws,"href","https://duckdb.org/docs/api/wasm"),h(ws,"rel","nofollow")},m(s,l){r(document.head,a),i(s,o,l),i(s,e,l),r(e,c),r(c,m),v(k,m,null),r(e,x),r(e,C),r(C,Ge),i(s,se,l),i(s,R,l),r(R,Me),r(R,K),r(K,Ye),r(R,ze),i(s,ee,l),i(s,O,l),r(O,As),r(As,He),r(O,Ue),r(O,Ls),r(Ls,Ve),i(s,ae,l),i(s,A,l),r(A,B),r(B,Ts),v(X,Ts,null),r(A,Qe),r(A,Ss),r(Ss,We),i(s,te,l),i(s,Z,l),r(Z,ss),r(ss,Je),r(Z,Ke),i(s,re,l),v(I,s,l),i(s,le,l),i(s,P,l),r(P,Xe),r(P,Fs),r(Fs,Ze),r(P,sa),r(P,es),r(es,Cs),r(Cs,ea),r(P,aa),i(s,oe,l),v(as,s,l),i(s,ne,l),i(s,N,l),r(N,ta),r(N,ts),r(ts,Rs),r(Rs,ra),r(N,la),i(s,pe,l),v(rs,s,l),i(s,ue,l),i(s,G,l),r(G,oa),r(G,ls),r(ls,Os),r(Os,na),r(G,pa),i(s,ce,l),v(os,s,l),i(s,ie,l),i(s,L,l),r(L,M),r(M,Bs),v(ns,Bs,null),r(L,ua),r(L,Is),r(Is,ca),i(s,he,l),i(s,Y,l),r(Y,ia),r(Y,ps),r(ps,ha),r(Y,fa),i(s,fe,l),i(s,D,l),r(D,ga),r(D,us),r(us,Ns),r(Ns,da),r(D,_a),r(D,cs),r(cs,Gs),r(Gs,ma),r(D,$a),i(s,ge,l),v(is,s,l),i(s,de,l),i(s,T,l),r(T,z),r(z,Ms),v(hs,Ms,null),r(T,ba),r(T,Ys),r(Ys,va),i(s,_e,l),i(s,ys,l),r(ys,wa),i(s,me,l),i(s,H,l),r(H,qa),r(H,fs),r(fs,zs),r(zs,ya),r(H,ja),i(s,$e,l),v(gs,s,l),i(s,be,l),i(s,U,l),r(U,ka),r(U,ds),r(ds,Hs),r(Hs,Ea),r(U,xa),i(s,ve,l),v(_s,s,l),i(s,we,l),i(s,S,l),r(S,V),r(V,Us),v(ms,Us,null),r(S,Pa),r(S,Vs),r(Vs,Da),i(s,qe,l),i(s,F,l),r(F,$s),r($s,Aa),r(F,La),r(F,bs),r(bs,Qs),r(Qs,Ta),r(F,Sa),i(s,ye,l),v(Q,s,l),i(s,je,l),i(s,js,l),r(js,Fa),i(s,ke,l),v(W,s,l),i(s,Ee,l),i(s,ks,l),r(ks,Ca),i(s,xe,l),v(J,s,l),i(s,Pe,l),i(s,vs,l),r(vs,ws),r(ws,Ra),r(vs,Oa),De=!0},p(s,[l]){const qs={};l&2&&(qs.$$scope={dirty:l,ctx:s}),I.$set(qs);const Ws={};l&2&&(Ws.$$scope={dirty:l,ctx:s}),Q.$set(Ws);const Js={};l&2&&(Js.$$scope={dirty:l,ctx:s}),W.$set(Js);const Ks={};l&2&&(Ks.$$scope={dirty:l,ctx:s}),J.$set(Ks)},i(s){De||(w(k.$$.fragment,s),w(X.$$.fragment,s),w(I.$$.fragment,s),w(as.$$.fragment,s),w(rs.$$.fragment,s),w(os.$$.fragment,s),w(ns.$$.fragment,s),w(is.$$.fragment,s),w(hs.$$.fragment,s),w(gs.$$.fragment,s),w(_s.$$.fragment,s),w(ms.$$.fragment,s),w(Q.$$.fragment,s),w(W.$$.fragment,s),w(J.$$.fragment,s),De=!0)},o(s){q(k.$$.fragment,s),q(X.$$.fragment,s),q(I.$$.fragment,s),q(as.$$.fragment,s),q(rs.$$.fragment,s),q(os.$$.fragment,s),q(ns.$$.fragment,s),q(is.$$.fragment,s),q(hs.$$.fragment,s),q(gs.$$.fragment,s),q(_s.$$.fragment,s),q(ms.$$.fragment,s),q(Q.$$.fragment,s),q(W.$$.fragment,s),q(J.$$.fragment,s),De=!1},d(s){t(a),s&&t(o),s&&t(e),y(k),s&&t(se),s&&t(R),s&&t(ee),s&&t(O),s&&t(ae),s&&t(A),y(X),s&&t(te),s&&t(Z),s&&t(re),y(I,s),s&&t(le),s&&t(P),s&&t(oe),y(as,s),s&&t(ne),s&&t(N),s&&t(pe),y(rs,s),s&&t(ue),s&&t(G),s&&t(ce),y(os,s),s&&t(ie),s&&t(L),y(ns),s&&t(he),s&&t(Y),s&&t(fe),s&&t(D),s&&t(ge),y(is,s),s&&t(de),s&&t(T),y(hs),s&&t(_e),s&&t(ys),s&&t(me),s&&t(H),s&&t($e),y(gs,s),s&&t(be),s&&t(U),s&&t(ve),y(_s,s),s&&t(we),s&&t(S),y(ms),s&&t(qe),s&&t(F),s&&t(ye),y(Q,s),s&&t(je),s&&t(js),s&&t(ke),y(W,s),s&&t(Ee),s&&t(ks),s&&t(xe),y(J,s),s&&t(Pe),s&&t(vs)}}}const Ut={local:"query-datasets-from-datasets-server",sections:[{local:"polars",sections:[{local:"lazy-api",title:"Lazy API"}],title:"Polars "},{local:"pandas",title:"Pandas"},{local:"duckdb",title:"DuckDB"}],title:"Query datasets from Datasets Server"};function Vt(j){return At(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Zt extends Et{constructor(a){super();xt(this,a,Vt,Ht,Pt,{})}}export{Zt as default,Ut as metadata};
